/**
 *  Name: Stuart Hansen
 *  Course: CSCI 241 - Computer Science I
 *  Section: 001 or 002
 *
 *  Project/Class Description
 *      This class times the Java library method to
 *      sort arrays.
 *
 *  Known Bugs: none
 */
    
import java.util.*;
import empirical.*;
    
public class AverageArraysDotSort
{
    private static int SIZE = 20000;  // The maximum size we will test
    private static int [] data;           // the data array
    private static long comparisons;      // the number of comparisons done
    private static AlgTimer timer = new AlgTimer();  // a Timer object


    public static void main (String [] args)
    {
        System.out.println ("Arrays.sort");
        MemUsed m = new MemUsed();
        m.reportMem();
        for (int i=0; i<5; i++) {
            comparisons = 0;
            
            // These two lines are a bit of fancy code to generate random arrays
            IntArrayFactory factory = new IntArrayFactory(SIZE);
            data = factory.randomPermutation();
            
	    System.out.println("Starting Timer");
            // Time the Java library sort
            timer.start();        
    	    Arrays.sort (data);
            timer.stop();
            System.out.println ("Array size = " + SIZE
                              + " MilliSeconds = " + timer.getMillis());
            m.reportMem();

        }
    }

}
